/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * ParserFileValidator.cpp
 *
 *  Created on: May 14, 2012
 *      Author: ankele
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include <string>
#include <boost/filesystem.hpp>
#include "ParserFileValidator.hpp"

#include "Parser/ParserTypes.hpp"
#include "Parser/FormatParserStorage.hpp"

bool ParserFileValidator::isValid(const boost::filesystem::path & _value) const
{
  for (ParserTypes t = ParserTypes_begin; t < ParserTypes_end; ++ t){
    const std::string dotted_suffix = std::string(".")+
        FormatParserStorage::getInstance().getSuffixFromType(t);
    //LOG(2, "DEBUG: ParserFileValidator compares " << _value.extension() << " with " << dotted_suffix << ".");
    if (_value.extension() == dotted_suffix)
      return true;
  }
  return false;
}

bool ParserFileValidator::operator==(const Validator<boost::filesystem::path> &_instance) const
{
  const ParserFileValidator *inst =
      dynamic_cast<const ParserFileValidator *>(&_instance);
  if (inst)
    return true;
  else
    return false;
}

Validator< boost::filesystem::path >* ParserFileValidator::clone() const
{
  Validator< boost::filesystem::path > *inst =
      new ParserFileValidator();
  return inst;
}




